com.jnape.palatable.lambda.semigroup.builtin

## Class LeftAll<L,R>

- java.lang.Object
- - com.jnape.palatable.lambda.semigroup.builtin.LeftAll<L,R>

- Type Parameters:
    `L` - The left parameter type
    `R` - The right parameter type
  All Implemented Interfaces:
    Fn1<Semigroup<L>,Fn1<Either<L,R>,Fn1<Either<L,R>,Either<L,R>>>>, Fn2<Semigroup<L>,Either<L,R>,Fn1<Either<L,R>,Either<L,R>>>, Fn3<Semigroup<L>,Either<L,R>,Either<L,R>,Either<L,R>>, SemigroupFactory<Semigroup<L>,Either<L,R>>, Applicative<Fn1<Either<L,R>,Fn1<Either<L,R>,Either<L,R>>>,Fn1<Semigroup<L>,?>>, Cartesian<Semigroup<L>,Fn1<Either<L,R>,Fn1<Either<L,R>,Either<L,R>>>,Fn1<?,?>>, Cocartesian<Semigroup<L>,Fn1<Either<L,R>,Fn1<Either<L,R>,Either<L,R>>>,Fn1<?,?>>, Contravariant<Semigroup<L>,Profunctor<?,Fn1<Either<L,R>,Fn1<Either<L,R>,Either<L,R>>>,Fn1<?,?>>>, Functor<Fn1<Either<L,R>,Fn1<Either<L,R>,Either<L,R>>>,Fn1<Semigroup<L>,?>>, Profunctor<Semigroup<L>,Fn1<Either<L,R>,Fn1<Either<L,R>,Either<L,R>>>,Fn1<?,?>>, Monad<Fn1<Either<L,R>,Fn1<Either<L,R>,Either<L,R>>>,Fn1<Semigroup<L>,?>>, MonadReader<Semigroup<L>,Fn1<Either<L,R>,Fn1<Either<L,R>,Either<L,R>>>,Fn1<Semigroup<L>,?>>, MonadRec<Fn1<Either<L,R>,Fn1<Either<L,R>,Either<L,R>>>,Fn1<Semigroup<L>,?>>, MonadWriter<Semigroup<L>,Fn1<Either<L,R>,Fn1<Either<L,R>,Either<L,R>>>,Fn1<Semigroup<L>,?>>

      public final class LeftAll<L,R>
      extends Object
      implements SemigroupFactory<Semigroup<L>,Either<L,R>>

  A `Semigroup` instance formed by ``Either`<L,R>` and a semigroup over `L`. The application to two `Either` values is right-biased, such that for a given `Either` `x` and `y`:
  - if `x` is a `Right` value, the result is `x`
  - if `y` is a `Right` value, the result is `y`
  - if both `x` and `y` are left values, the result is the application of the x and y values in terms of the provided semigroup, wrapped in `Either.left(L)`

  For the `Monoid`, see `LeftAll`.

  See Also:
    `Semigroup`, `RightAll`, `Either`

- - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `Semigroup<Either<L,R>>` | `checkedApply(Semigroup<L> lSemigroup)` Invoke this function with the given argument, potentially throwing any `Throwable`.
    `static <L,R> LeftAll<L,R>` | `leftAll()`
    `static <L,R> Semigroup<Either<L,R>>` | `leftAll(Semigroup<L> lSemigroup)`
    `static <L,R> Fn1<Either<L,R>,Either<L,R>>` | `leftAll(Semigroup<L> lSemigroup, Either<L,R> x)`
    `static <L,R> Either<L,R>` | `leftAll(Semigroup<L> lSemigroup, Either<L,R> x, Either<L,R> y)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface com.jnape.palatable.lambda.functions.specialized.SemigroupFactory

      `apply, checkedApply`

    - ### Methods inherited from interface com.jnape.palatable.lambda.functions.Fn3

      `apply, apply, checkedApply, compose, contraMap, diMapL, discardR, flip, fn3, fn3, fn3, uncurry, widen`

    - ### Methods inherited from interface com.jnape.palatable.lambda.functions.Fn2

      `curried, curry, fn2, fromBiFunction, toBiFunction`

    - ### Methods inherited from interface com.jnape.palatable.lambda.functions.Fn1

      `andThen, carry, cartesian, censor, choose, cocartesian, diMap, diMapR, discardL, flatMap, fmap, fn1, fromFunction, lazyZip, listens, local, pure, pureFn1, thunk, toFunction, trampolineM, zip, zip`

    - ### Methods inherited from interface com.jnape.palatable.lambda.monad.Monad

      `join`

    - ### Methods inherited from interface com.jnape.palatable.lambda.functor.Functor

      `coerce`

- - ### Method Detail

    - #### checkedApply

          public Semigroup<Either<L,R>> checkedApply(Semigroup<L> lSemigroup)

      Description copied from interface: `Fn2`
      Invoke this function with the given argument, potentially throwing any `Throwable`.
      Specified by:
        `checkedApply` in interface `Fn1<Semigroup<L>,Fn1<Either<L,R>,Fn1<Either<L,R>,Either<L,R>>>>`
      Specified by:
        `checkedApply` in interface `Fn2<Semigroup<L>,Either<L,R>,Fn1<Either<L,R>,Either<L,R>>>`
      Specified by:
        `checkedApply` in interface `SemigroupFactory<Semigroup<L>,Either<L,R>>`
      Parameters:
        `lSemigroup` - the argument
      Returns:
        the result of the function application

    - #### leftAll

          public static <L,R> LeftAll<L,R> leftAll()

    - #### leftAll

          public static <L,R> Semigroup<Either<L,R>> leftAll(Semigroup<L> lSemigroup)

    - #### leftAll

          public static <L,R> Fn1<Either<L,R>,Either<L,R>> leftAll(Semigroup<L> lSemigroup,
                                                                   Either<L,R> x)

    - #### leftAll

          public static <L,R> Either<L,R> leftAll(Semigroup<L> lSemigroup,
                                                  Either<L,R> x,
                                                  Either<L,R> y)